/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2014 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2014 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by Spansion LLC, USA
 *  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2014 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2014 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2014 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2011-2014 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: vasyslog.c 355 2014-09-17 02:17:36Z witz-itoyo $
 */

/*
 *		ѿΥƥ饤֥
 */
#include "t_syslog.h"
#include <stdarg.h>

#ifndef TOPPERS_OMIT_SYSLOG

void
syslog(uint32 prio, const char8 *format, ...)
{
	SYSLOG	syslog;
	va_list	ap;
	uint32	i;
	char8	c;
	boolean	lflag;

	syslog.logtype = LOG_TYPE_COMMENT;
	syslog.loginfo[0] = (sintptr) format;
	i = 1U;
	va_start(ap, format);

	while (((c = *format++) != '\0') && (i < TMAX_LOGINFO)) {
		if (c != '%') {
			continue;
		}

		lflag = FALSE;
		c = *format++;
		while (('0' <= c) && (c <= '9')) {
			c = *format++;
		}
		if (c == 'l') {
			lflag = TRUE;
			c = *format++;
		}
		switch (c) {
		case 'd':
			syslog.loginfo[i++] = (lflag != FALSE) ? (sintptr) va_arg(ap, sint32)
								  : (sintptr) va_arg(ap, sint32);
			break;
		case 'u':
		case 'x':
		case 'X':
			syslog.loginfo[i++] = (lflag != FALSE) ? (sintptr) va_arg(ap, uint32)
								  : (sintptr) va_arg(ap, uint32);
			break;
		case 'p':
			syslog.loginfo[i++] = (sintptr) va_arg(ap, void *);
			break;
		case 'c':
			syslog.loginfo[i++] = (sintptr) va_arg(ap, sint32);
			break;
		case 's':
			syslog.loginfo[i++] = (sintptr) va_arg(ap, const char8 *);
			break;
		case '\0':
			format--;
			break;
		default:
			/* 嵭Υʳξ硤ϹԤʤ */
			break;
		}
	}
	va_end(ap);
	(void) syslog_wri_log(prio, &syslog);
}

#endif /* TOPPERS_OMIT_SYSLOG */
